package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesOrderRule;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/01/15 9:31 上午
 * @Description:
 **/
public interface IOrderRuleService {
    /**
     * 新增单据规则
     * @param orderRule
     * @return
     */
    MesOrderRule insertOrderRule(MesOrderRule orderRule);
    /**
     * 修改单据规则
     * @param orderRule
     * @return
     */
    MesOrderRule updateOrderRule(MesOrderRule orderRule);

    /**
     * 查询单据规则分页
     * @param orderRule
     * @param pager
     * @return
     */
    ListPager<MesOrderRule> queryOrderRuleByPager(MesOrderRule orderRule, Pager pager);

    /**
     * 根据ID启用或禁用单据规则
     * @param id
     * @param status
     * @return
     */
    int updateOrderRuleIsValidById(long id, Integer status);
}
