package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@ApiModel("出货检验项目信息model")
public class OqcProjectModel implements Serializable {

    private static final long serialVersionUID = -3732982699213266046L;

    @ApiParam("ID")
    private Long id;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("操作人")
    public String userInfo;

    @ApiParam("序号")
    private Double seq;

    @ApiParam("产品类别")
    private String categoryCode3;

    @ApiParam("物料编码")
    private String partNo;

    @ApiParam("检验项目")
    private String oqcProject;

    @ApiParam("判断基准")
    private String standard;

    @ApiParam("上限值")
    private String upLimit;

    @ApiParam("下限值")
    private String downLimit;

    @ApiParam("启用器具")
    private String appliance;

    @ApiParam("检验类型")
    private Integer oqcType;

    @ApiParam("多个物料")
    private List<String> partNoList;

    @ApiParam("多个ID")
    private List<Long> idList;

    @ApiParam("状态")
    private Integer status;

}
