package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@ApiModel("工序BOM")
public class SxProcessBomModel implements Serializable {

    private static final long serialVersionUID = -6969883509079802100L;

    @ApiParam("ID")
    private Long id;

    @ApiParam("成品物料编码")
    private String partNo;

    @ApiParam("成品物料名称")
    private String partNameRdd;

    @ApiParam("原材料物料编码")
    private String itemPartNo;

    @ApiParam("原材料物料名称")
    private String itemPartName;

    @ApiParam("工序代码")
    private String processCode;

    @ApiParam("工序名称")
    private String processName;

    @ApiParam(value = "子零件数量")
    private Double qty;

    @ApiParam("是否绑定关键件")
    private Integer isBindKey;

    @ApiParam("是否可重复")
    private Integer isRepeat;

    @ApiParam("是否检查")
    private Integer isCheck;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("有效性")
    public Integer isValid;

    @ApiParam("有效性")
    public String isValidName;

    @ApiParam("是否已删除")
    public Integer isDeleted;

    @ApiParam("是否已删除")
    public String isDeletedName;

    @ApiParam("创建用户")
    public String createUser;

    @ApiParam("创建日期")
    public String createDatetime;

    @ApiParam("修改人")
    public String modifyUser;

    @ApiParam("修改日期")
    public String modifyDatetime;

    @ApiParam("是否绑定关键件")
    private String isBindKeyName;

    @ApiParam("是否可重复")
    private String isRepeatName;

    @ApiParam("是否检查")
    private String isCheckName;

    @ApiParam("关键件序号")
    private Double seq;

}
