package cn.estsh.i3plus.ext.mes.pojo.model.bu3;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @DESCRIPTION:
 * @USER: wangjie
 * @DATE: 2022-11-01 15:54
 */
@Data
@ApiModel("日常点检报表确认记录MODEL")
public class SxDailyCheckConfirmRecordModel implements Serializable {

    private static final long serialVersionUID = -1705245717789068046L;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("操作人")
    public String userInfo;

    @ApiParam(value = "单据类型")
    public Integer orderType;

    @ApiParam("设备编号")
    private String equNo;

    @ApiParam("工作中心代码")
    private String workCenterCode;

    @ApiParam("工作中心名称")
    private String workCenterName;

    @ApiParam("作业时间(年月)")
    private String workTime;

    @ApiParam("班次代码")
    private String shiftCode;

    @ApiParam("级别")
    private String level;

    @ApiParam("级别几次")
    private String times;

    @ApiParam("间隔时间(h)")
    private String intervalTime;

    @ApiParam("确认日期")
    private String confirmDatetime;

    @ApiParam("确认日期")
    private String confirmDatetimeYmd;

    @ApiParam("创建用户")
    public String createUser;

    @ApiParam("创建日期")
    public String createDatetime;

    @ApiParam("修改人")
    public String modifyUser;

    @ApiParam("修改日期")
    public String modifyDatetime;

    @ApiParam(value = "单据类型")
    public String orderTypeName;

    @ApiParam("级别")
    private String levelName;

    public SxDailyCheckConfirmRecordModel() {}

    public SxDailyCheckConfirmRecordModel basic(String organizeCode, String userInfo) {
        this.organizeCode = organizeCode;
        this.userInfo = userInfo;
        return this;
    }

    public SxDailyCheckConfirmRecordModel(String level, String createUser, String confirmDatetime) {
        this.level = level;
        this.createUser = createUser;
        this.confirmDatetime = confirmDatetime;
    }
}
