package cn.estsh.i3plus.ext.mes.pojo.model.bu3;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @DESCRIPTION:
 * @USER: wangjie
 * @DATE: 2022-11-01 15:54
 */
@Data
@ApiModel("停开机时间记录统计MODEL")
public class SxShiftProdCenterRecordStatisticsModel implements Serializable {

    private static final long serialVersionUID = 6956856780358717267L;

    @ApiParam("ID")
    public String id;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam(value = "创建时间")
    public String createDatetime;

    @ApiParam("工作中心代码")
    private String workCenterCode;

    @ApiParam("工作中心名称")
    private String workCenterName;

    @ApiParam("系别")
    private String isDont;

    @ApiParam("班次代码")
    private String shiftCode;

    @ApiParam("班次名称")
    private String shiftName;

    @ApiParam("数据时间维度")
    private String dataType;

    @ApiParam("作业时间")
    private String workTime;

    @ApiParam("作业内容代码")
    private String prodCode;

    @ApiParam("作业内容名称")
    private String prodName;

    @ApiParam("物料编码")
    private String partNo;

    @ApiParam("物料名称")
    private String partNameRdd;

    @ApiParam("作业类型")
    private Integer prodType;

    @ApiParam(value = "产品类别代码")
    public String categoryCode;

    @ApiParam(value = "事业别代码")
    public String careerCode;

    @ApiParam("人件费")
    private String personnelCost;

    @ApiParam("统计数")
    private Double statistics;

    @ApiParam("分组信息")
    private String groupInfo;

}
