package cn.estsh.i3plus.ext.mes.apiservice.dao.bu;

import cn.estsh.i3plus.ext.mes.pojo.bean.SxMesDataTravel;
import cn.estsh.i3plus.ext.mes.pojo.model.bu.SxMesDataTravelExtModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

public interface IMesDataTravelDao {
    /**
     * 按条件分页查询数据履历信息
     * @param mesDataTravelExt
     * @param pager
     * @return
     */
    @ApiOperation(value = "按条件分页查询数据履历信息", notes = "按条件分页查询数据履历信息")
    List<SxMesDataTravelExtModel> querySxMesDataTravelExtByPager(SxMesDataTravel mesDataTravelExt, Pager pager);

    /**
     * 按条件查找数据履历信息分页数量
     *
     * @param mesDataTravelExt
     * @return
     */
    @ApiOperation(value = "按条件查找数据履历信息分页数量", notes = "按条件查找数据履历信息分页数量")
    int querySxMesDataTravelExtCount(SxMesDataTravel mesDataTravelExt);
}
