package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年06月16日 9:56
 */
@Data
@ApiModel("工程不良率")
public class ProjectBadRateModel implements Serializable {

    private static final long serialVersionUID = -1757024732425264738L;

    @ApiParam("日期")
    private String workTime;

    @ApiParam("产线代码")
    private String workCenterCode;

    @ApiParam("产线名称")
    private String workCenterName;

    @ApiParam("产线描述")
    private String workCenterDesc;

    @ApiParam("综合能率")
    private Double totalRate;

    @ApiParam("作业能率")
    private Double workRate;

    @ApiParam("工程不良率")
    private Double defectiveRate;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("生产计划达成率")
    private Double productPlanRate;

    @ApiParam("生产实绩")
    private Integer produceQty;

    @ApiParam("计划数量")
    private Integer planQty;
}
