package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * @Description: PS部件点检model
 * @Author: shun.cui
 * @date: 2021/5/7  15:10
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Api("PS部件点检model")
public class WmsPsCheckModel implements Serializable {
    @ApiParam("工厂代码")
    private String organizeCode;
    @ApiParam("生产工单号")
    private String workOrderNo;
    @ApiParam("生产线")
    private String workCenterCode;
    @ApiParam("物料批次")
    private String dateCode;
    @ApiParam("绑定开始时间")
    private String createDateTimeStart;
    @ApiParam("绑定结束时间")
    private String createDateTimeEnd;
    @ApiParam("成品物料编码")
    private String prodPartNo;
    @ApiParam("生产条码")
    private String sn;
    @ApiParam("物料编码")
    private String partNo;
    @ApiParam("绑定时间")
    private String date;
    @ApiParam("每页显示")
    private int pageSize;
    @ApiParam("当前页")
    private int currentPage;

    @ApiParam("工单号")
    private String orderNo;
    @ApiParam("物料编码")
    private String itemPartNo;
    @ApiParam("是否PS部件点检")
    private Integer psPartCheckFlag;
    @ApiParam("是否PS部件点检")
    private String psPartCheckFlagName;
}
