package cn.estsh.i3plus.ext.mes.pojo.model.bu;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Description:
 * @Author: xinwang.yi
 * @Date: 2022/10/13 13:58
 * @Modify:
 */
@Data
@Api("操作报错记录 MODEL")
public class BuBusiErrorMessageModel implements Serializable {

    private static final long serialVersionUID = 4375569988073830306L;

    @ApiParam("成品物料编码")
    private String partNo;

    @ApiParam("成品物料名称")
    private String partNameRdd;

    @ApiParam("原材料物料编码")
    private String itemPartNo;

    @ApiParam("原材料物料名称")
    private String itemPartName;

    @ApiParam(value = "产线代码")
    private String workCenterCode;

    @ApiParam(value = "生产工单号")
    public String workOrderNo;

    @ApiParam(value = "工位代码")
    public String workCellCode;

    @ApiParam("工序代码")
    private String processCode;

    @ApiParam("条码")
    private String serialNumber;

    @ApiParam("操作密码")
    private String password;

    @ApiParam("报错工步代码")
    private String errorStepCode;

    @ApiParam("报错工步名称")
    private String errorStepName;

    @ApiParam("报错信息")
    private String errorMessage;

    @ApiParam("输入内容")
    private String scanInfo;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("创建开始时间")
    private String createDatetimeStart;

    @ApiParam("创建结束时间")
    private String createDatetimeEnd;

}
