package cn.estsh.i3plus.ext.mes.pojo.model.bu;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import javax.persistence.Column;
import java.io.Serializable;

@Data
@ApiModel("人员与工序model")
public class EmployeeAndProcessBindModel implements Serializable {

    private static final long serialVersionUID = 947303280558014915L;

    @ApiParam(value = "员工代码")
    private String employeeCode;

    @ApiParam(value = "技能看板工序代码(取【技能看板工序信息】中的工序代码)")
    private String skillKanbanProcessCode;

    @ApiParam(value = "员工名称")
    private String employeeName;

    @ApiParam(value = "技能看板工序名称")
    private String skillKanbanProcessName;

    @ApiParam(value = "产线代码(取组织模型菜单中的产线代码)")
    private String workCenterCode;

    @ApiParam("id")
    private Long id;

    @ApiParam(value = "有效性")
    private Integer isValid;

    @ApiParam(value = "是否已删除")
    private Integer isDeleted;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("创建人")
    private String createUser;

    @ApiParam("创建时间")
    private String createDatetime;

    @ApiParam("更新人")
    private String modifyUser;

    @ApiParam("更新时间")
    private String modifyDatetime;

}
