package cn.estsh.i3plus.ext.mes.pojo.model.bu;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Transient;
import java.io.Serializable;


@Data
@ApiModel("工序标签标示model")
public class ProcessLabelMarkingModel implements Serializable {
    private static final long serialVersionUID = 5364403174123920444L;

    @ApiParam(value = "工序标签标示代码")
    private String processLabelCode;

    @ApiParam(value = "工序标签标示名称")
    private String processLabelName;

    @ApiParam(value = "颜色(颜色枚举：黄底红字、黄底白字、黄底黑字、灰底黑字)")
    private String color;

    @ApiParam(value = "背景颜色(颜色枚举：黄底红字、黄底白字、黄底黑字、灰底黑字)")
    private String bgColor;

    @ApiParam(value = "字体颜色(颜色枚举：黄底红字、黄底白字、黄底黑字、灰底黑字)")
    private String textColor;

    @ApiParam(value = "位置(位置枚举：左上、左下、右上、右下)")
    private String location;

    @ApiParam(value = "技能看板工序代码")
    private String skillKanbanProcessCode;

    @ApiParam(value = "技能看板工序名称")
    private String skillKanbanProcessName;

    @ApiParam(value = "颜色(颜色枚举：黄底红字、黄底白字、黄底黑字、灰底黑字)")
    private String colorName;

    @ApiParam(value = "位置(位置枚举：左上、左下、右上、右下)")
    private String locationName;

    @ApiParam(value = "位置排序序号")
    private Integer seq;

    @Column(name = "EMPLOYEE_CODE")
    @ApiParam(value = "员工代码")
    private String employeeCode;

    @ApiParam(value = "与前端联调字段")
    private String address;


}
