package cn.estsh.i3plus.ext.mes.pojo.model.bu3;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @DESCRIPTION:
 * @USER: wangjie
 * @DATE: 2022-11-01 15:54
 */
@Data
@ApiModel("品番主表MODEL")
public class SxProdDataPfzbModel implements Serializable {

    private static final long serialVersionUID = 641103622272810701L;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("工厂代码")
    public String org;

    @ApiParam("组织名称")
    public String orgName;

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("零件名称")
    private String partName;

    @ApiParam("物料类型")
    private String pptCode;

    @ApiParam("物料类型名称")
    private String pptName;

    @ApiParam("分类1")
    private String categoryCode1;

    @ApiParam("分类1")
    private String categoryCode1Name;

    @ApiParam("分类3")
    private String categoryCode3;

    @ApiParam("分类3")
    private String categoryCode3Name;

    @ApiParam("标准工数")
    private Double standardWork;

    @ApiParam("标准工数")
    private String standardWorkStr;

    @ApiParam("更新时间")
    private String modifyDatetime;

    public SxProdDataPfzbModel() {}

    public SxProdDataPfzbModel(String org, String orgName) {
        this.org = org;
        this.orgName = orgName;
    }
}
